package org.topbraid.spin.constraints;

import java.util.Collection;

import org.topbraid.spin.model.TemplateCall;

import com.hp.hpl.jena.rdf.model.Resource;


/**
 * An object representing a failure of a SPIN constraint.
 * 
 * @author Holger Knublauch
 */
public class ConstraintViolation {
	
	private Collection<TemplateCall> fixes;
	
	private String message;
	
	private Collection<SimplePropertyPath> paths;
	
	private Resource root;
	
	
	public ConstraintViolation(Resource root, 
				Collection<SimplePropertyPath> paths,
				Collection<TemplateCall> fixes,
				String message) {
		this.root = root;
		this.paths = paths;
		this.fixes = fixes;
		this.message = message;
	}
	
	
	public Collection<TemplateCall> getFixes() {
		return fixes;
	}
	
	
	public String getMessage() {
		return message;
	}
	
	
	public Collection<SimplePropertyPath> getPaths() {
		return paths;
	}
	

	public Resource getRoot() {
		return root;
	}
}
