package org.topbraid.spin.model;

import java.util.List;


/**
 * A SELECT query.
 * 
 * @author Holger Knublauch
 */
public interface Select extends SolutionModifierQuery {

	/**
	 * Gets a list of result variables, or null if we have a star
	 * results list.  Note that the "variables" may in fact be
	 * wrapped aggregations.
	 * @return the result variables
	 */
	List<Variable> getResultVariables();
	
	
	/**
	 * Checks is this query has the DISTINCT flag set.
	 * @return true if distinct
	 */
	boolean isDistinct();
	

	/**
	 * Checks if this query has the REDUCED flag set.
	 * @return true if reduced
	 */
	boolean isReduced();
}
