package org.topbraid.spin.model.impl;

import java.util.LinkedList;
import java.util.List;

import org.topbraid.spin.model.Construct;
import org.topbraid.spin.model.TripleTemplate;
import org.topbraid.spin.model.print.PrintContext;
import org.topbraid.spin.vocabulary.SP;

import com.hp.hpl.jena.enhanced.EnhGraph;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.RDFNode;


public class ConstructImpl extends QueryImpl implements Construct {

	public ConstructImpl(Node node, EnhGraph graph) {
		super(node, graph);
	}

	
	public List<TripleTemplate> getTemplates() {
		List<TripleTemplate> results = new LinkedList<TripleTemplate>();
		for(RDFNode next : getList(SP.templates)) {
			if(next != null && next.isResource()) {
				results.add((TripleTemplate) next.as(TripleTemplate.class));
			}
		}
		return results;
	}


	public void print(PrintContext context) {
		printComment(context);
		printPrefixes(context);
		context.printKeyword("CONSTRUCT");
		context.print(" {");
		context.println();
		for(TripleTemplate template : getTemplates()) {
			context.printIndentation(1);
			template.print(context);
			context.print(" .");
			context.println();
		}
		context.print("}");
		printStringFrom(context);
		context.println();
		printWhere(context);
		printSolutionModifiers(context);
	}
}
