package org.topbraid.spin.model.impl;

import org.topbraid.spin.model.Service;
import org.topbraid.spin.model.print.PrintContext;
import org.topbraid.spin.model.visitor.ElementVisitor;
import org.topbraid.spin.vocabulary.SP;

import com.hp.hpl.jena.enhanced.EnhGraph;
import com.hp.hpl.jena.graph.Node;
import com.hp.hpl.jena.rdf.model.Statement;

public class ServiceImpl extends ElementImpl implements Service {
	
	public ServiceImpl(Node node, EnhGraph enhGraph) {
		super(node, enhGraph);
	}

	
	public String getServiceURI() {
		Statement s = getProperty(SP.serviceURI);
		if(s != null && s.getObject().isURIResource()) {
			return s.getResource().getURI();
		}
		else {
			return null;
		}
	}


	public void print(PrintContext p) {
		p.printKeyword("SERVICE");
		printNestedElementList(p);
	}


	public void visit(ElementVisitor visitor) {
		visitor.visit(this);
	}
}
