package org.topbraid.spin.model.visitor;

import org.topbraid.spin.model.ElementList;
import org.topbraid.spin.model.Filter;
import org.topbraid.spin.model.Let;
import org.topbraid.spin.model.NamedGraph;
import org.topbraid.spin.model.NotExists;
import org.topbraid.spin.model.Optional;
import org.topbraid.spin.model.Service;
import org.topbraid.spin.model.SubQuery;
import org.topbraid.spin.model.TriplePath;
import org.topbraid.spin.model.TriplePattern;
import org.topbraid.spin.model.Union;


/**
 * An interface to visit the various kinds of Elements.
 * 
 * @author Holger Knublauch
 */
public interface ElementVisitor {
	
	void visit(ElementList elementList);
	
	
	void visit(Filter filter);
	
	
	void visit(Let let);
	
	
	void visit(NamedGraph namedGraph);
	
	
	void visit(NotExists notExists);
	
	
	void visit(Optional optional);

	
	void visit(Service service);
	
	
	void visit(SubQuery subQuery);
	
	
	void visit(TriplePath triplePath);

	
	void visit(TriplePattern triplePattern);
	
	
	void visit(Union union);
}
